Panda3D

Loading...
Searching...
No Matches
Public Types | Public Member Functions | Static Public Member Functions | Public Attributes | Friends | List of all members
EggGroupNode Class Reference

A base class for nodes in the hierarchy that are not leaf nodes. More...

`#include "eggGroupNode.h"`

Inheritance diagram for EggGroupNode:

## Public Types
typedef Children::const_iterator | const_iterator
typedef Children::const_pointer | const_pointer
typedef Children::const_reference | const_reference
typedef Children::const_reverse_iterator | const_reverse_iterator
typedef Children::difference_type | difference_type
typedef Children::const_iterator | iterator
typedef Children::const_pointer | pointer
typedef Children::const_reference | reference
typedef Children::const_reverse_iterator | reverse_iterator
typedef Children::size_type | size_type
enum | TriangulateFlags { T_polygon = 0x001 , T_convex = 0x002 , T_composite = 0x004 , T_recurse = 0x008 , T_flat_shaded = 0x010 }

## Public Member Functions
| EggGroupNode (const EggGroupNode &copy)
| EggGroupNode (const std::string &name="")
EggNode * | add_child (EggNode *node)
| Adds the indicated child to the group and returns it.
void | apply_first_attribute (bool recurse)
| Sets the first vertex of the triangle (or each component) to the primitive normal and/or color, if the primitive is flat-shaded.
void | apply_last_attribute (bool recurse)
| Sets the last vertex of the triangle (or each component) to the primitive normal and/or color, if the primitive is flat-shaded.
iterator | begin () const
void | clear ()
void | clear_connected_shading ()
| Resets the connected_shading information on all primitives at this node and below, so that it may be accurately rederived by the next call to get_connected_shading().
bool | empty () const
iterator | end () const
iterator | erase (iterator first, iterator last)
iterator | erase (iterator position)
EggNode * | find_child (const std::string &name) const
| Returns the child of this node whose name is the indicated string, or NULL if there is no child of this node by that name.
void | force_filenames (const Filename &directory)
| Similar to resolve_filenames, but each non-absolute filename encountered is arbitrarily taken to be in the indicated directory, whether or not the so- named filename exists.
virtual TypeHandle | force_init_type ()
void | get_connected_shading ()
| Queries the connected_shading information on all primitives at this node and below, to ensure that it has been completely filled in before we start mucking around with vertices.
EggNode * | get_first_child ()
| Returns the first child in the group's list of children, or NULL if the list of children is empty.
EggNode * | get_next_child ()
| Returns the next child in the group's list of children since the last call to get_first_child() or get_next_child(), or NULL if the last child has been returned.
virtual TypeHandle | get_type () const
bool | has_absolute_pathnames () const
| Returns true if any nodes at this level and below include a reference to a file via an absolute pathname, or false if all references are relative.
virtual bool | has_normals () const
| Returns true if any of the primitives (e.g.
virtual bool | has_primitives () const
| Returns true if there are any primitives (e.g.
iterator | insert (iterator position, PT(EggNode) x)
virtual bool | joint_has_primitives () const
| Returns true if there are any primitives (e.g.
void | make_point_primitives ()
| Creates PointLight primitives to reference any otherwise unreferences vertices discovered in this group or below.
void | mesh_triangles (int flags)
| Combine triangles together into triangle strips, at this group and below.
EggGroupNode & | operator= (const EggGroupNode &copy)
void | post_apply_flat_attribute (bool recurse)
| Intended as a followup to apply_last_attribute(), this also sets an attribute on the first vertices of the primitive, if they don't already have an attribute set, just so they end up with *something*.
| PT (EggNode) remove_child(EggNode *node)
reverse_iterator | rbegin () const
void | rebuild_vertex_pools (EggVertexPools &vertex_pools, unsigned int max_vertices, bool recurse)
| Copies vertices used by the primitives at this group node (and below, if recurse is true) into one or more new vertex pools, and updates the primitives to reference these pools.
void | recompute_polygon_normals (CoordinateSystem cs=CS_default)
| Recomputes all the polygon normals for polygon geometry at this group node and below so that they accurately reflect the vertex positions.
bool | recompute_tangent_binormal (const GlobPattern &uv_name)
| This function recomputes the tangent and binormal for the named texture coordinate set for all vertices at this level and below.
bool | recompute_tangent_binormal (const vector_string &names)
| This function recomputes the tangent and binormal for the named texture coordinate sets.
bool | recompute_tangent_binormal_auto ()
| This function recomputes the tangent and binormal for any texture coordinate set that affects a normal map.
void | recompute_vertex_normals (double threshold, CoordinateSystem cs=CS_default)
| Recomputes all the vertex normals for polygon geometry at this group node and below so that they accurately reflect the vertex positions.
int | remove_invalid_primitives (bool recurse)
| Removes primitives at this level and below which appear to be degenerate; e.g.
int | remove_unused_vertices (bool recurse)
| Removes all vertices from VertexPools within this group or below that are not referenced by at least one primitive.
int | rename_nodes (vector_string strip_prefix, bool recurse)
| Rename by stripping out the prefix.
reverse_iterator | rend () const
void | replace (iterator position, PT(EggNode) x)
| Replaces the node at the indicated position with the indicated node.
void | resolve_filenames (const DSearchPath &searchpath)
| Walks the tree and attempts to resolve any filenames encountered.
void | reverse_vertex_ordering ()
| Reverses the vertex ordering of all polygons defined at this node and below.
size_type | size () const
void | steal_children (EggGroupNode &other)
| Moves all the children from the other node to this one.
void | strip_normals ()
| Removes all normals from primitives, and the vertices they reference, at this node and below.
int | triangulate_polygons (int flags)
| Replace all higher-order polygons at this point in the scene graph and below with triangles.
void | unify_attributes (bool use_connected_shading, bool allow_per_primitive, bool recurse)
| Applies per-vertex normal and color to all vertices, if they are in fact per-vertex (and different for each vertex), or moves them to the primitive if they are all the same.
virtual void | write (std::ostream &out, int indent_level) const
| Writes the group and all of its children to the indicated output stream in Egg format.
Public Member Functions inherited from EggNode
| EggNode (const EggNode &copy)
| EggNode (const std::string &name="")
void | apply_texmats ()
| Applies the texture matrices to the UV's of the vertices that reference them, and then removes the texture matrices from the textures themselves.
virtual EggRenderMode * | determine_alpha_mode ()
| Walks back up the hierarchy, looking for an EggGroup or EggPrimitive or some such object at this level or above this node that has an alpha_mode other than AM_unspecified.
virtual EggRenderMode * | determine_bin ()
| Walks back up the hierarchy, looking for an EggGroup or EggPrimitive or some such object at this level or above this node that has a bin specified.
virtual bool | determine_decal ()
| Walks back up the hierarchy, looking for an EggGroup at this level or above that has the "decal" flag set.
virtual EggRenderMode * | determine_depth_offset ()
| Walks back up the hierarchy, looking for an EggGroup or EggPrimitive or some such object at this level or above this node that has a depth_offset specified.
virtual EggRenderMode * | determine_depth_test_mode ()
| Walks back up the hierarchy, looking for an EggGroup or EggPrimitive or some such object at this level or above this node that has a depth_test_mode other than DTM_unspecified.
virtual EggRenderMode * | determine_depth_write_mode ()
| Walks back up the hierarchy, looking for an EggGroup or EggPrimitive or some such object at this level or above this node that has a depth_write_mode other than DWM_unspecified.
virtual EggRenderMode * | determine_draw_order ()
| Walks back up the hierarchy, looking for an EggGroup or EggPrimitive or some such object at this level or above this node that has a draw_order specified.
virtual bool | determine_indexed ()
| Walks back up the hierarchy, looking for an EggGroup at this level or above that has the "indexed" scalar set.
virtual EggRenderMode * | determine_visibility_mode ()
| Walks back up the hierarchy, looking for an EggGroup or EggPrimitive or some such object at this level or above this node that has a visibility_mode other than VM_unspecified.
void | flatten_transforms ()
| Removes any transform and instance records from this node in the scene graph and below.
int | get_depth () const
const LMatrix4d & | get_node_frame () const
| Returns the coordinate frame of the node itself.
const LMatrix4d & | get_node_frame_inv () const
| Returns the inverse of the matrix returned by get_node_frame().
const LMatrix4d * | get_node_frame_inv_ptr () const
| Returns either a NULL pointer or a unique pointer shared by nodes with the same get_node_frame_inv() matrix.
const LMatrix4d * | get_node_frame_ptr () const
| Returns either a NULL pointer or a unique pointer shared by nodes with the same get_node_frame() matrix.
const LMatrix4d & | get_node_to_vertex () const
| Returns the transformation matrix suitable for converting vertices in the coordinate space of the node to the appropriate coordinate space for storing in the egg file.
const LMatrix4d * | get_node_to_vertex_ptr () const
| Returns either a NULL pointer or a unique pointer shared by nodes with the same get_node_to_vertex() matrix.
EggGroupNode * | get_parent () const
const LMatrix4d & | get_vertex_frame () const
| Returns the coordinate frame of the vertices referenced by primitives at or under this node.
const LMatrix4d & | get_vertex_frame_inv () const
| Returns the inverse of the matrix returned by get_vertex_frame().
const LMatrix4d * | get_vertex_frame_inv_ptr () const
| Returns either a NULL pointer or a unique pointer shared by nodes with the same get_vertex_frame_inv() matrix.
const LMatrix4d * | get_vertex_frame_ptr () const
| Returns either a NULL pointer or a unique pointer shared by nodes with the same get_vertex_frame() matrix.
const LMatrix4d & | get_vertex_to_node () const
| Returns the transformation matrix suitable for converting the vertices as read from the egg file into the coordinate space of the node.
const LMatrix4d * | get_vertex_to_node_ptr () const
| Returns either a NULL pointer or a unique pointer shared by nodes with the same get_vertex_to_node() matrix.
virtual bool | is_anim_matrix () const
| Returns true if this node represents a table of animation transformation data, false otherwise.
virtual bool | is_joint () const
| Returns true if this particular node represents a <Joint> entry or not.
bool | is_local_coord () const
| Returns true if this node's vertices are not in the global coordinate space.
bool | is_under_instance () const
| Returns true if there is an <Instance> node somewhere in the egg tree at or above this node, false otherwise.
bool | is_under_transform () const
| Returns true if there is a <Transform> entry somewhere in the egg tree at or above this node, false otherwise.
EggNode & | operator= (const EggNode &copy)
bool | parse_egg (const std::string &egg_syntax)
| Parses the egg syntax given in the indicate string as if it had been read from the egg file within this object's definition.
int | rename_node (vector_string strip_prefix)
| Rename by stripping out the prefix.
void | test_under_integrity () const
void | transform (const LMatrix4d &mat)
| Applies the indicated transformation to the node and all of its descendants.
void | transform_vertices_only (const LMatrix4d &mat)
| Applies the indicated transformation only to vertices that appear in global space within vertex pools at this node and below.
Public Member Functions inherited from EggNamedObject
| EggNamedObject (const EggNamedObject &copy)
| EggNamedObject (const std::string &name="")
EggNamedObject & | operator= (const EggNamedObject &copy)
void | output (std::ostream &out) const
void | write_header (std::ostream &out, int indent_level, const char *egg_keyword) const
| Writes the first line of the egg object, e.g.
Public Member Functions inherited from EggObject
| EggObject (const EggObject &copy)
virtual EggTransform * | as_transform ()
| Returns this object cross-cast to an EggTransform pointer, if it inherits from EggTransform, or NULL if it does not.
void | clear_user_data ()
| Removes *all* user data pointers from the node.
void | clear_user_data (TypeHandle type)
| Removes the user data pointer of the indicated type.
EggUserData * | get_user_data () const
| Returns the user data pointer most recently stored on this object, or NULL if nothing was previously stored.
EggUserData * | get_user_data (TypeHandle type) const
| Returns the user data pointer of the indicated type, if it exists, or NULL if it does not.
bool | has_user_data () const
| Returns true if a generic user data pointer has recently been set and not yet cleared, false otherwise.
bool | has_user_data (TypeHandle type) const
| Returns true if the user data pointer of the indicated type has been set, false otherwise.
EggObject & | operator= (const EggObject &copy)
void | set_user_data (EggUserData *user_data)
| Sets the user data associated with this object.
Public Member Functions inherited from TypedReferenceCount
| TypedReferenceCount (const TypedReferenceCount &copy)
void | operator= (const TypedReferenceCount &copy)
Public Member Functions inherited from TypedObject
| TypedObject (const TypedObject &copy)=default
TypedObject * | as_typed_object ()
| Returns the object, upcast (if necessary) to a TypedObject pointer.
const TypedObject * | as_typed_object () const
| Returns the object, upcast (if necessary) to a TypedObject pointer.
int | get_best_parent_from_Set (const std::set< int > &) const
int | get_type_index () const
| Returns the internal index number associated with this object's TypeHandle, a unique number for each different type.
bool | is_exact_type (TypeHandle handle) const
| Returns true if the current object is the indicated type exactly.
bool | is_of_type (TypeHandle handle) const
| Returns true if the current object is or derives from the indicated type.
TypedObject & | operator= (const TypedObject &copy)=default
Public Member Functions inherited from MemoryBase
void | operator delete (void *, void *)
void | operator delete (void *ptr)
void | operator delete[] (void *, void *)
void | operator delete[] (void *ptr)
void * | operator new (size_t size)
void * | operator new (size_t size, void *ptr)
void * | operator new[] (size_t size)
void * | operator new[] (size_t size, void *ptr)
Public Member Functions inherited from ReferenceCount
int | get_ref_count () const
WeakReferenceList * | get_weak_list () const
| Returns the WeakReferenceList associated with this ReferenceCount object.
bool | has_weak_list () const
| Returns true if this particular ReferenceCount object has a WeakReferenceList created, false otherwise.
void | local_object ()
| This function should be called, once, immediately after creating a new instance of some ReferenceCount-derived object on the stack.
void | ref () const
| Explicitly increments the reference count.
bool | ref_if_nonzero () const
| Atomically increases the reference count of this object if it is not zero.
bool | test_ref_count_integrity () const
| Does some easy checks to make sure that the reference count isn't completely bogus.
bool | test_ref_count_nonzero () const
| Does some easy checks to make sure that the reference count isn't zero, or completely bogus.
virtual bool | unref () const
| Explicitly decrements the reference count.
bool | unref_if_one () const
| Atomically decreases the reference count of this object if it is one.
WeakReferenceList * | weak_ref ()
| Adds the indicated PointerToVoid as a weak reference to this object.
void | weak_unref ()
| Removes the indicated PointerToVoid as a weak reference to this object.
Public Member Functions inherited from Namable
| Namable (const std::string &initial_name="")
void | clear_name ()
| Resets the Namable's name to empty.
const std::string & | get_name () const
bool | has_name () const
| Returns true if the Namable has a nonempty name set, false if the name is empty.
void | output (std::ostream &out) const
| Outputs the Namable.
void | set_name (const std::string &name)

## Static Public Member Functions
static TypeHandle | get_class_type ()
static void | init_type ()
static bool | is_right (const LVector2d &v1, const LVector2d &v2)
| Returns true if the 2-d v1 is to the right of v2.
Static Public Member Functions inherited from EggNode
static TypeHandle | get_class_type ()
static void | init_type ()
Static Public Member Functions inherited from EggNamedObject
static TypeHandle | get_class_type ()
static void | init_type ()
Static Public Member Functions inherited from EggObject
static TypeHandle | get_class_type ()
static void | init_type ()
Static Public Member Functions inherited from TypedReferenceCount
static TypeHandle | get_class_type ()
static void | init_type ()
Static Public Member Functions inherited from TypedObject
static TypeHandle | get_class_type ()
static void | init_type ()
| This function is declared non-inline to work around a compiler bug in g++ 2.96.
Static Public Member Functions inherited from ReferenceCount
static TypeHandle | get_class_type ()
static void | init_type ()
Static Public Member Functions inherited from Namable
static TypeHandle | get_class_type ()
static void | init_type ()

## Public Attributes
| get_children
Public Attributes inherited from EggNode
| get_depth
| Returns the number of nodes above this node in the egg hierarchy.
| get_parent
Public Attributes inherited from TypedObject
| get_type
Public Attributes inherited from ReferenceCount
| get_ref_count
| Returns the current reference count.
Public Attributes inherited from Namable
| get_name
| set_name

## Friends
class | EggMaterialCollection
class | EggTextureCollection

## Detailed Description

A base class for nodes in the hierarchy that are not leaf nodes.

(See also EggGroup, which is specifically the "<Group>" node in egg.)

An EggGroupNode is an STL-style container of pointers to EggNodes, like a vector. Functions push_back()/pop_back() and insert()/erase() are provided to manipulate the list. The list may also be operated on (read-only) via iterators and begin()/end().

Definition at line 46 of file eggGroupNode.h.

## Member Typedef Documentation

## ◆ const_iterator

typedef Children::const_iterator EggGroupNode::const_iterator

Definition at line 83 of file eggGroupNode.h.

## ◆ const_pointer

typedef Children::const_pointer EggGroupNode::const_pointer

Definition at line 78 of file eggGroupNode.h.

## ◆ const_reference

typedef Children::const_reference EggGroupNode::const_reference

Definition at line 81 of file eggGroupNode.h.

## ◆ const_reverse_iterator

typedef Children::const_reverse_iterator EggGroupNode::const_reverse_iterator

Definition at line 85 of file eggGroupNode.h.

## ◆ difference_type

typedef Children::difference_type EggGroupNode::difference_type

Definition at line 87 of file eggGroupNode.h.

## ◆ iterator

typedef Children::const_iterator EggGroupNode::iterator

Definition at line 82 of file eggGroupNode.h.

## ◆ pointer

typedef Children::const_pointer EggGroupNode::pointer

Definition at line 77 of file eggGroupNode.h.

## ◆ reference

typedef Children::const_reference EggGroupNode::reference

Definition at line 80 of file eggGroupNode.h.

## ◆ reverse_iterator

typedef Children::const_reverse_iterator EggGroupNode::reverse_iterator

Definition at line 84 of file eggGroupNode.h.

## ◆ size_type

typedef Children::size_type EggGroupNode::size_type

Definition at line 86 of file eggGroupNode.h.

## Member Enumeration Documentation

## ◆ TriangulateFlags

enum EggGroupNode::TriangulateFlags

Definition at line 133 of file eggGroupNode.h.

## Constructor & Destructor Documentation

## ◆ EggGroupNode() [1/2]

EggGroupNode::EggGroupNode | ( | const std::string & | name = "" | ) |
| inline explicit

Definition at line 61 of file eggGroupNode.h.

## ◆ EggGroupNode() [2/2]

EggGroupNode::EggGroupNode | ( | const EggGroupNode & | copy | ) |

Definition at line 50 of file eggGroupNode.cxx.

## ◆ ~EggGroupNode()

EggGroupNode::~EggGroupNode | ( |  | ) |
| virtual

Definition at line 74 of file eggGroupNode.cxx.

## Member Function Documentation

## ◆ add_child()

EggNode * EggGroupNode::add_child | ( | EggNode * | node | ) |

Adds the indicated child to the group and returns it.

If the child node is already a child of some other node, removes it first.

Definition at line 242 of file eggGroupNode.cxx.

References ReferenceCount::test_ref_count_integrity().

Referenced by EggXfmSAnim::EggXfmSAnim(), EggXfmSAnim::add_component_data(), EggXfmSAnim::add_data(), DaeCharacter::build_table(), XFileAnimationSet::create_hierarchy(), MaxNodeTree::get_egg_group(), MayaNodeTree::get_egg_group(), MaxNodeTree::get_egg_table(), MayaNodeTree::get_egg_table(), SomethingToEggConverter::handle_external_reference(), EggMatrixTablePointer::make_new_joint(), XFileMesh::set_egg_parent(), QtessSurface::tesselate(), and EggMesherFanMaker::unroll().

## ◆ apply_first_attribute()

void EggGroupNode::apply_first_attribute | ( | bool | recurse | ) |

Sets the first vertex of the triangle (or each component) to the primitive normal and/or color, if the primitive is flat-shaded.

This reflects the DirectX convention of storing flat-shaded properties on the first vertex, although it is not usually a convention in Egg.

This may create redundant vertices in the vertex pool, so it may be a good idea to follow this up with remove_unused_vertices().

Definition at line 1038 of file eggGroupNode.cxx.

References EggPrimitive::apply_first_attribute(), and TypedObject::is_of_type().

Referenced by EggLoader::make_polyset().

## ◆ apply_last_attribute()

void EggGroupNode::apply_last_attribute | ( | bool | recurse | ) |

Sets the last vertex of the triangle (or each component) to the primitive normal and/or color, if the primitive is flat-shaded.

This reflects the OpenGL convention of storing flat-shaded properties on the last vertex, although it is not usually a convention in Egg.

This may create redundant vertices in the vertex pool, so it may be a good idea to follow this up with remove_unused_vertices().

Definition at line 1012 of file eggGroupNode.cxx.

References EggPrimitive::apply_last_attribute(), and TypedObject::is_of_type().

## ◆ begin()

EggGroupNode::iterator EggGroupNode::begin | ( |  | ) | const

Definition at line 110 of file eggGroupNode.cxx.

## ◆ clear()

void EggGroupNode::clear | ( |  | ) |

Definition at line 202 of file eggGroupNode.cxx.

## ◆ clear_connected_shading()

void EggGroupNode::clear_connected_shading | ( |  | ) |

Resets the connected_shading information on all primitives at this node and below, so that it may be accurately rederived by the next call to get_connected_shading().

It may be a good idea to call remove_unused_vertices() as well, to establish the correct connectivity between common vertices.

Definition at line 916 of file eggGroupNode.cxx.

References EggPrimitive::clear_connected_shading(), and TypedObject::is_of_type().

## ◆ empty()

bool EggGroupNode::empty | ( |  | ) | const

Definition at line 186 of file eggGroupNode.cxx.

## ◆ end()

EggGroupNode::iterator EggGroupNode::end | ( |  | ) | const

Definition at line 118 of file eggGroupNode.cxx.

## ◆ erase() [1/2]

EggGroupNode::iterator EggGroupNode::erase | ( | iterator | first,
|  | iterator | last )

Definition at line 160 of file eggGroupNode.cxx.

## ◆ erase() [2/2]

EggGroupNode::iterator EggGroupNode::erase | ( | iterator | position | ) |

Definition at line 151 of file eggGroupNode.cxx.

## ◆ find_child()

EggNode * EggGroupNode::find_child | ( | const std::string & | name | ) | const

Returns the child of this node whose name is the indicated string, or NULL if there is no child of this node by that name.

Does not search recursively.

Definition at line 295 of file eggGroupNode.cxx.

Referenced by EggXfmSAnim::add_component_data(), EggXfmSAnim::add_data(), and EggXfmSAnim::set_value().

## ◆ force_filenames()

void EggGroupNode::force_filenames | ( | const Filename & | directory | ) |

Similar to resolve_filenames, but each non-absolute filename encountered is arbitrarily taken to be in the indicated directory, whether or not the so- named filename exists.

Definition at line 405 of file eggGroupNode.cxx.

References EggTexture::get_alpha_filename, EggFilenameNode::get_filename(), EggTexture::has_alpha_filename, Filename::is_local(), TypedObject::is_of_type(), and EggTexture::set_alpha_filename.

## ◆ force_init_type()

virtual TypeHandle EggGroupNode::force_init_type | ( |  | ) |
| inline virtual

Reimplemented from EggNode.

Definition at line 247 of file eggGroupNode.h.

## ◆ get_class_type()

static TypeHandle EggGroupNode::get_class_type | ( |  | ) |
| inline static

Definition at line 236 of file eggGroupNode.h.

## ◆ get_connected_shading()

void EggGroupNode::get_connected_shading | ( |  | ) |

Queries the connected_shading information on all primitives at this node and below, to ensure that it has been completely filled in before we start mucking around with vertices.

Definition at line 936 of file eggGroupNode.cxx.

References EggPrimitive::get_connected_shading, and TypedObject::is_of_type().

## ◆ get_first_child()

EggNode * EggGroupNode::get_first_child | ( |  | ) |

Returns the first child in the group's list of children, or NULL if the list of children is empty.

Can be used with get_next_child() to return the complete list of children without using the iterator class; however, this is non-thread-safe, and so is not recommended except for languages other than C++ which cannot use the iterators.

Definition at line 214 of file eggGroupNode.cxx.

References get_next_child().

## ◆ get_next_child()

EggNode * EggGroupNode::get_next_child | ( |  | ) |

Returns the next child in the group's list of children since the last call to get_first_child() or get_next_child(), or NULL if the last child has been returned.

Can be used with get_first_child() to return the complete list of children without using the iterator class; however, this is non- thread-safe, and so is not recommended except for languages other than C++ which cannot use the iterators.

It is an error to call this without previously calling get_first_child().

Definition at line 230 of file eggGroupNode.cxx.

Referenced by get_first_child().

## ◆ get_type()

virtual TypeHandle EggGroupNode::get_type | ( |  | ) | const
| inline virtual

Reimplemented from EggNode.

Definition at line 244 of file eggGroupNode.h.

## ◆ has_absolute_pathnames()

bool EggGroupNode::has_absolute_pathnames | ( |  | ) | const

Returns true if any nodes at this level and below include a reference to a file via an absolute pathname, or false if all references are relative.

Definition at line 312 of file eggGroupNode.cxx.

References EggTexture::get_alpha_filename, EggFilenameNode::get_filename(), has_absolute_pathnames(), EggTexture::has_alpha_filename, Filename::is_local(), and TypedObject::is_of_type().

Referenced by has_absolute_pathnames().

## ◆ has_normals()

bool EggGroupNode::has_normals | ( |  | ) | const
| virtual

Returns true if any of the primitives (e.g.

polygons) defined within this group or below have either face or vertex normals defined, false otherwise.

Reimplemented from EggNode.

Definition at line 1121 of file eggGroupNode.cxx.

## ◆ has_primitives()

bool EggGroupNode::has_primitives | ( |  | ) | const
| virtual

Returns true if there are any primitives (e.g.

polygons) defined within this group or below, false otherwise.

Reimplemented from EggNode.

Definition at line 1081 of file eggGroupNode.cxx.

## ◆ init_type()

static void EggGroupNode::init_type | ( |  | ) |
| inline static

Definition at line 239 of file eggGroupNode.h.

## ◆ insert()

EggGroupNode::iterator EggGroupNode::insert | ( | iterator | position,
|  | PT(EggNode) | x )

Definition at line 142 of file eggGroupNode.cxx.

## ◆ is_right()

bool EggGroupNode::is_right | ( | const LVector2d & | v1,
|  | const LVector2d & | v2 )
| inline static

Returns true if the 2-d v1 is to the right of v2.

Definition at line 17 of file eggGroupNode.I.

## ◆ joint_has_primitives()

bool EggGroupNode::joint_has_primitives | ( |  | ) | const
| virtual

Returns true if there are any primitives (e.g.

polygons) defined within this group or below, but the search does not include nested joints.

Reimplemented from EggNode.

Definition at line 1099 of file eggGroupNode.cxx.

References EggNode::is_joint().

## ◆ make_point_primitives()

void EggGroupNode::make_point_primitives | ( |  | ) |

Creates PointLight primitives to reference any otherwise unreferences vertices discovered in this group or below.

Definition at line 770 of file eggGroupNode.cxx.

References EggVertexPool::add_unused_vertices_to_prim(), make_point_primitives(), and steal_children().

Referenced by make_point_primitives().

## ◆ mesh_triangles()

void EggGroupNode::mesh_triangles | ( | int | flags | ) |

Combine triangles together into triangle strips, at this group and below.

Definition at line 750 of file eggGroupNode.cxx.

References EggMesher::mesh(), and mesh_triangles().

Referenced by EggLoader::make_polyset(), and mesh_triangles().

## ◆ operator=()

EggGroupNode & EggGroupNode::operator= | ( | const EggGroupNode & | copy | ) |

Definition at line 61 of file eggGroupNode.cxx.

## ◆ post_apply_flat_attribute()

void EggGroupNode::post_apply_flat_attribute | ( | bool | recurse | ) |

Intended as a followup to apply_last_attribute(), this also sets an attribute on the first vertices of the primitive, if they don't already have an attribute set, just so they end up with *something*.

Definition at line 1060 of file eggGroupNode.cxx.

References TypedObject::is_of_type(), and EggPrimitive::post_apply_flat_attribute().

Referenced by EggLoader::make_polyset().

## ◆ rbegin()

EggGroupNode::reverse_iterator EggGroupNode::rbegin | ( |  | ) | const

Definition at line 126 of file eggGroupNode.cxx.

## ◆ rebuild_vertex_pools()

void EggGroupNode::rebuild_vertex_pools | ( | EggVertexPools & | vertex_pools,
|  | unsigned int | max_vertices,
|  | bool | recurse )

Copies vertices used by the primitives at this group node (and below, if recurse is true) into one or more new vertex pools, and updates the primitives to reference these pools.

It is up to the caller to parent the newly-created vertex pools somewhere appropriate in the egg hierarchy.

No more than max_vertices will be placed into any one vertex pool. This is the sole criteria for splitting vertex pools.

Definition at line 1144 of file eggGroupNode.cxx.

References EggPrimitive::add_vertex(), EggPrimitive::clear(), EggVertex::copy_grefs_from(), EggVertexPool::create_unique_vertex(), EggVertexPool::find_matching_vertex(), EggCompositePrimitive::get_component, EggCompositePrimitive::get_num_components, TypedObject::is_of_type(), EggCompositePrimitive::set_component, and EggVertexPool::size().

Referenced by EggLoader::make_polyset().

## ◆ recompute_polygon_normals()

void EggGroupNode::recompute_polygon_normals | ( | CoordinateSystem | cs = CS_default | ) |

Recomputes all the polygon normals for polygon geometry at this group node and below so that they accurately reflect the vertex positions.

Normals are removed from the vertices and defined only on polygons, giving the geometry a faceted appearance.

This function also removes degenerate polygons that do not have enough vertices to define a normal. It does not affect normals for other kinds of primitives like Nurbs or Points.

This function does not remove or adjust vertices in the vertex pool; it only adds new vertices with the normals removed. Thus, it is a good idea to call remove_unused_vertices() after calling this.

Definition at line 540 of file eggGroupNode.cxx.

References EggVertex::copy_grefs_from(), EggVertexPool::create_unique_vertex(), EggVertex::get_pool(), EggPrimitive::get_vertex, TypedObject::is_of_type(), EggPolygon::recompute_polygon_normal(), and EggPrimitive::set_vertex.

Referenced by EggData::recompute_polygon_normals().

## ◆ recompute_tangent_binormal() [1/2]

bool EggGroupNode::recompute_tangent_binormal | ( | const GlobPattern & | uv_name | ) |

This function recomputes the tangent and binormal for the named texture coordinate set for all vertices at this level and below.

Use the empty string for the default texture coordinate set.

It is necessary for each vertex to already have a normal (or at least a polygon normal), as well as a texture coordinate in the named texture coordinate set, before calling this function. You might precede this with recompute_vertex_normals() to ensure that the normals exist.

Like recompute_vertex_normals(), this function does not remove or adjust vertices in the vertex pool; it only adds new vertices with the new tangents and binormals computed. Thus, it is a good idea to call remove_unused_vertices() after calling this.

Definition at line 638 of file eggGroupNode.cxx.

Referenced by recompute_tangent_binormal(), and recompute_tangent_binormal_auto().

## ◆ recompute_tangent_binormal() [2/2]

bool EggGroupNode::recompute_tangent_binormal | ( | const vector_string & | names | ) |

This function recomputes the tangent and binormal for the named texture coordinate sets.

Returns true if anything was done.

Definition at line 661 of file eggGroupNode.cxx.

References recompute_tangent_binormal().

## ◆ recompute_tangent_binormal_auto()

bool EggGroupNode::recompute_tangent_binormal_auto | ( |  | ) |

This function recomputes the tangent and binormal for any texture coordinate set that affects a normal map.

Returns true if anything was done.

Definition at line 682 of file eggGroupNode.cxx.

References EggTextureCollection::find_used_textures(), EggTexture::get_uv_name, and recompute_tangent_binormal().

## ◆ recompute_vertex_normals()

void EggGroupNode::recompute_vertex_normals | ( | double | threshold,
|  | CoordinateSystem | cs = CS_default )

Recomputes all the vertex normals for polygon geometry at this group node and below so that they accurately reflect the vertex positions.

A shared edge between two polygons (even in different groups) is considered smooth if the angle between the two edges is less than threshold degrees.

This function also removes degenerate polygons that do not have enough vertices to define a normal. It does not affect normals for other kinds of primitives like Nurbs or Points.

This function does not remove or adjust vertices in the vertex pool; it only adds new vertices with the correct normals. Thus, it is a good idea to call remove_unused_vertices() after calling this.

Definition at line 474 of file eggGroupNode.cxx.

References ReferenceCount::ref().

Referenced by EggData::recompute_vertex_normals().

## ◆ remove_invalid_primitives()

int EggGroupNode::remove_invalid_primitives | ( | bool | recurse | ) |

Removes primitives at this level and below which appear to be degenerate; e.g.

polygons with fewer than 3 vertices, etc. Returns the number of primitives removed.

Definition at line 878 of file eggGroupNode.cxx.

References EggPrimitive::cleanup(), and TypedObject::is_of_type().

## ◆ remove_unused_vertices()

int EggGroupNode::remove_unused_vertices | ( | bool | recurse | ) |

Removes all vertices from VertexPools within this group or below that are not referenced by at least one primitive.

Also collapses together equivalent vertices, and renumbers all vertices after the operation so their indices are consecutive, beginning at zero. Returns the total number of vertices removed.

Note that this operates on the VertexPools within this group level, without respect to primitives that reference these vertices (unlike other functions like strip_normals()). It is therefore most useful to call this on the EggData root, rather than on a subgroup within the hierarchy, since a VertexPool may appear anywhere in the hierarchy.

Definition at line 840 of file eggGroupNode.cxx.

References EggVertexPool::empty(), TypedObject::is_of_type(), and EggVertexPool::remove_unused_vertices().

## ◆ rename_nodes()

int EggGroupNode::rename_nodes | ( | vector_string | strip_prefix,
|  | bool | recurse )

Rename by stripping out the prefix.

Definition at line 799 of file eggGroupNode.cxx.

References EggNode::rename_node(), and rename_nodes().

Referenced by rename_nodes().

## ◆ rend()

EggGroupNode::reverse_iterator EggGroupNode::rend | ( |  | ) | const

Definition at line 134 of file eggGroupNode.cxx.

## ◆ replace()

void EggGroupNode::replace | ( | iterator | position,
|  | PT(EggNode) | x )

Replaces the node at the indicated position with the indicated node.

It is an error to call this with an invalid position iterator (e.g. end()).

Definition at line 174 of file eggGroupNode.cxx.

## ◆ resolve_filenames()

void EggGroupNode::resolve_filenames | ( | const DSearchPath & | searchpath | ) |

Walks the tree and attempts to resolve any filenames encountered.

This looks up filenames along the specified search path; it does not automatically search the model_path for missing files.

Definition at line 367 of file eggGroupNode.cxx.

References EggTexture::get_alpha_filename, EggFilenameNode::get_default_extension(), EggFilenameNode::get_filename(), VirtualFileSystem::get_global_ptr(), EggTexture::has_alpha_filename, TypedObject::is_of_type(), Filename::resolve_filename(), and EggTexture::set_alpha_filename.

## ◆ reverse_vertex_ordering()

void EggGroupNode::reverse_vertex_ordering | ( |  | ) |

Reverses the vertex ordering of all polygons defined at this node and below.

Does not change the surface normals, if any.

Definition at line 443 of file eggGroupNode.cxx.

References TypedObject::is_of_type(), and EggPrimitive::reverse_vertex_ordering().

## ◆ size()

EggGroupNode::size_type EggGroupNode::size | ( |  | ) | const

Definition at line 194 of file eggGroupNode.cxx.

## ◆ steal_children()

void EggGroupNode::steal_children | ( | EggGroupNode & | other | ) |

Moves all the children from the other node to this one.

This is especially useful because the group node copy assignment operator does not copy children.

Definition at line 277 of file eggGroupNode.cxx.

Referenced by EggJointNodePointer::do_finish_reparent(), SomethingToEggConverter::handle_external_reference(), make_point_primitives(), EggData::merge(), EggMesher::mesh(), PT(), and EggData::read().

## ◆ strip_normals()

void EggGroupNode::strip_normals | ( |  | ) |

Removes all normals from primitives, and the vertices they reference, at this node and below.

This function does not remove or adjust vertices in the vertex pool; it only adds new vertices with the normal removed. Thus, it is a good idea to call remove_unused_vertices() after calling this.

Definition at line 591 of file eggGroupNode.cxx.

References EggVertex::copy_grefs_from(), EggVertexPool::create_unique_vertex(), EggVertex::get_pool(), EggPrimitive::get_vertex, TypedObject::is_of_type(), and EggPrimitive::set_vertex.

Referenced by EggData::strip_normals().

## ◆ triangulate_polygons()

int EggGroupNode::triangulate_polygons | ( | int | flags | ) |

Replace all higher-order polygons at this point in the scene graph and below with triangles.

Returns the total number of new triangles produced, less degenerate polygons removed.

If flags contains T_polygon and T_convex, both concave and convex polygons will be subdivided into triangles; with only T_polygon, only concave polygons will be subdivided, and convex polygons will be largely unchanged.

Definition at line 712 of file eggGroupNode.cxx.

References TypedObject::is_of_type().

Referenced by EggLoader::make_polyset().

## ◆ unify_attributes()

void EggGroupNode::unify_attributes | ( | bool | use_connected_shading,
|  | bool | allow_per_primitive,
|  | bool | recurse )

Applies per-vertex normal and color to all vertices, if they are in fact per-vertex (and different for each vertex), or moves them to the primitive if they are all the same.

After this call, either the primitive will have normals or its vertices will, but not both. Ditto for colors.

If use_connected_shading is true, each polygon is considered in conjunction with all connected polygons; otherwise, each polygon is considered individually.

If allow_per_primitive is false, S_per_face or S_overall will treated like S_per_vertex: normals and colors will always be assigned to the vertices. In this case, there will never be per-primitive colors or normals after this call returns. On the other hand, if allow_per_primitive is true, then S_per_face means that normals and colors should be assigned to the primitives, and removed from the vertices, as described above.

This may create redundant vertices in the vertex pool, so it may be a good idea to follow this up with remove_unused_vertices().

Definition at line 973 of file eggGroupNode.cxx.

References EggPrimitive::get_connected_shading, EggPrimitive::get_shading, TypedObject::is_of_type(), and EggPrimitive::unify_attributes().

## ◆ write()

void EggGroupNode::write | ( | std::ostream & | out,
|  | int | indent_level ) const
| virtual

Writes the group and all of its children to the indicated output stream in Egg format.

Implements EggNode.

Reimplemented in EggGroup, EggTable, and EggXfmSAnim.

Definition at line 83 of file eggGroupNode.cxx.

Referenced by EggGroup::write(), and EggTable::write().

## Friends And Related Symbol Documentation

## ◆ EggMaterialCollection

friend class EggMaterialCollection
| friend

Definition at line 253 of file eggGroupNode.h.

## ◆ EggTextureCollection

friend class EggTextureCollection
| friend

Definition at line 252 of file eggGroupNode.h.

## Member Data Documentation

## ◆ get_children

EggGroupNode::get_children

Definition at line 112 of file eggGroupNode.h.

The documentation for this class was generated from the following files:

- panda/src/egg/eggGroupNode.h
- panda/src/egg/eggGroupNode.cxx
- panda/src/egg/eggGroupNode.I